"""BSMP Constants."""

# --- Reserved Address IDs ---
ID_ADDR_MASTER = 0
ID_ADDR_BROADCAST = 255

# --- Reserved Group IDs ---
ID_STD_GROUP_ALL = 0
ID_STD_GROUP_READONLY = 1
ID_STD_GROUP_WRITE = 2

# --- Query Commands ---
CMD_CMD_QUERY_PROTOCOL_VERSION = 0x00
CMD_PROTOCOL_VERSION = 0x01
CMD_CMD_QUERY_LIST_OF_VARIABLES = 0x02
CMD_LIST_OF_VARIABLE = 0x03
CMD_QUERY_LIST_OF_GROUP_OF_VARIABLES = 0x04
CMD_LIST_OF_GROUP_OF_VARIABLES = 0x05
CMD_QUERY_GROUP_OF_VARIABLES = 0x06
CMD_GROUP_OF_VARIABLES = 0x07
CMD_QUERY_LIST_OF_CURVES = 0x08
CMD_LIST_OF_CURVES = 0x09
CMD_QUERY_CURVE_CHECKSUM = 0x0A
CMD_CURVE_CHECKSUM = 0x0B
CMD_QUERY_LIST_OF_FUNCTIONS = 0x0C
CMD_LIST_OF_FUNCTIONS = 0x0D

# --- Reading Commands ---
CMD_READ_VARIABLE = 0x10
CMD_VARIABLE_VALUE = 0x11
CMD_READ_GROUP_OF_VARIABLES = 0x12
CMD_GROUP_OF_VARIABLES_VALUE = 0x13

# --- Writing Commands ---
CMD_WRITE_VARIABLE = 0x20
CMD_WRITE_GROUP_OF_VARIABLES = 0x22
CMD_BINARY_OPERATION_IN_A_VARIABLE = 0x24
CMD_BINARY_OPERATION_IN_A_GROUP = 0x26
CMD_WRITE_AND_READ_VARIABLES = 0x28

# --- Group of Variables Manipulation Commnads ---
CMD_CREATE_GROUP_OF_VARIABLES = 0x30
CMD_REMOVE_ALL_GROUPS_OF_VARIABLES = 0x32

# --- Curve Transfer Commands ---
CMD_REQUEST_CURVE_BLOCK = 0x40
CMD_CURVE_BLOCK = 0x41
CMD_RECALCULATE_CURVE_CHECKSUM = 0x42

# --- Function Execution Commands ---
CMD_EXECUTE_FUNCTION = 0x50
CMD_FUNCTION_RETURN = 0x51
CMD_FUNCTION_ERROR = 0x53

# --- Error Commands ---
ACK_OK = 0xE0
ACK_MALFORMED_MESSAGE = 0xE1
ACK_OPERATION_NOT_SUPPORTED = 0xE2
ACK_INVALID_ID = 0xE3
ACK_INVALID_VALUE = 0xE4
ACK_INVALID_PAYLOAD_SIZE = 0xE5
ACK_READ_ONLY = 0xE6
ACK_INSUFFICIENT_MEMORY = 0xE7
ACK_RESOURCE_BUSY = 0xE8
